VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CSharedTimer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' *********************************************************************
'  Copyright 1998 Karl E. Peterson, All Rights Reserved
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long

Private m_ShowColons As Boolean
Private m_TmrID As Long

Private Const tmrDelay = 500

Public Event Timer(ByVal ShowColons As Boolean)

' ****************************************************
'  Initialization and Termination
' ****************************************************
Private Sub Class_Initialize()
   '
   ' Set default values for members
   '
   m_ShowColons = True
   '
   ' Start timer
   '
   m_TmrID = SetTimer(0&, 0&, tmrDelay, AddressOf TimerProc)
End Sub

Private Sub Class_Terminate()
   '
   ' Kill timer
   '
   Call KillTimer(0&, m_TmrID)
End Sub

' ****************************************************
'  Public Methods
' ****************************************************
Public Sub RaiseEvents()
   m_ShowColons = Not m_ShowColons
   RaiseEvent Timer(m_ShowColons)
End Sub
